package jalview.ws2.client.api;

import java.util.List;

import jalview.ws2.actions.api.ActionI;
import jalview.ws2.api.WebService;

/*
 * A view of services that allows to retrieve the services by the type
 * of action.
 */
public interface WebServiceProviderI
{
  /**
   * Retrieve list of all web services.
   * 
   * @return all web services
   */
  public List<WebService<?>> getServices();

  /**
   * Retrieve services by their action type.
   * 
   * @param type
   *          action type
   * @return list of services
   */
  public <A extends ActionI<?>> List<WebService<A>> getServices(Class<A> type);
}
